<?php

error_reporting(E_ALL);

/**
TP Content Slider for Joomla! CMS
Version: 1.0
Compability: Joomla 1.5.x

Created by: Jerry Wijaya and Andy Sikumbang
Released by: TemplatePlazza.com  - Best Joomla! Templates
Date Release: July 2008

Based on: jQuery Coda Slider Effect tutorial by http://jqueryfordesigners.com

Copyright: 2008 - TemplatePlazza and Jerry Wijaya (http://www.jerrywijaya.com)
**/

// no direct access
defined('_JEXEC') or die('Restricted access');

$moduleid = rand();
$catid	= $params->get( 'catid', 'catid' );
$limit	= $params->get( 'limit', 300 );
$show_tab_name = $params->get( 'show_tab_name', '1' );
$show_title = $params->get( 'show_title', '1' );
$show_limit = (int) $params->get( 'show_limit', 5 );
$order_by = $params->get( 'order_by', 'a.ordering' );
$order_sort = $params->get( 'order_sort', 'desc' );

$slider_width = $params->get( 'slider_width', '520' );

$scroll_width = $params->get( 'scroll_width', '520' );
$scroll_height = $params->get( 'scroll_height', '250' );

$scrollButtons_top = $params->get( 'scrollButtons_top', '150' );

$scrollContainer_padding = $params->get( 'scrollContainer_padding', '20' );
$scrollContainer_width = $params->get( 'scrollContainer_width', '210' );
$scrollContainer_height = $params->get( 'scrollContainer_height', '480' );

global $mainframe;

$db			=& JFactory::getDBO();
$user		=& JFactory::getUser();
$aid		= $user->get('aid', 0);

$contentConfig = &JComponentHelper::getParams( 'com_content' );
$access		= !$contentConfig->get('shownoauth');

$nullDate	= $db->getNullDate();

$date =& JFactory::getDate();
$now = $date->toMySQL();

$where		= 'a.state = 1'
	. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
	. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
	;

if ($catid)
{
	$ids = explode( ',', $catid );
	JArrayHelper::toInteger( $ids );
	$catCondition = ' AND (cc.id=' . implode( ' OR cc.id=', $ids ) . ')';
}

// Content Items only
$query = 'SELECT a.*, ' .
	' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
	' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
	' FROM #__content AS a' .
	' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
	' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
	' WHERE '. $where .' AND s.id > 0' .
	($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
	($catid ? $catCondition : '').
	' AND s.published = 1' .
	' AND cc.published = 1' .
	' ORDER BY '. $order_by . ' ' . $order_sort;

$document =& JFactory::getDocument();
$db->setQuery($query, 0, $show_limit);
$tpcontentslider = $db->loadObjectList();
if(count($tpcontentslider)) {
	if(!defined( '_TP_CONTENT_SLIDER' )) {
	
		define( '_TP_CONTENT_SLIDER', 1 );

		$document->addStyleSheet($mainframe->getBasePath( 0, true ).'modules/mod_tpcontentslider/tpcontentslider/tpcontentslider.css');
		$document->addScript($mainframe->getBasePath( 0, true ).'modules/mod_tpcontentslider/tpcontentslider/jquery-1.2.6.js');
		$document->addScript($mainframe->getBasePath( 0, true ).'modules/mod_tpcontentslider/tpcontentslider/jquery.scrollTo-1.3.3.js');
		$document->addScript($mainframe->getBasePath( 0, true ).'modules/mod_tpcontentslider/tpcontentslider/jquery.localscroll-1.2.5.js');
		$document->addScript($mainframe->getBasePath( 0, true ).'modules/mod_tpcontentslider/tpcontentslider/jquery.serialScroll-1.2.1.js');

		$css = "
		<style type='text/css'>
		.tpc_slider {
		    width: ".$slider_width."px;
		}
		
		#scroll {
		    height: ".$scroll_height."px;
		";
		
		if(strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'msie 6') !== false) {
		$css .= "
		    width: ".($slider_width-2)."px;
		";
		} else {
		$css .= "
		    width: ".$slider_width."px;
		";
		}

		$css .= "
		}
		.scrollButtons {
		    top: ".$scrollButtons_top."px;
		}
		
		#scrollContainer div.panel {
		    padding: ".$scrollContainer_padding."px;
			padding-top:0;
		    height: ".$scrollContainer_height."px;
		 ";
		 
		if(strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'msie 6') !== false) {
		 $css .= "
		    width: ".(($slider_width + 10) - ($scrollContainer_padding *2))."px;
			";
		} else {
		 $css .= "
		    width: ".($slider_width - ($scrollContainer_padding *2))."px;
			";
		}
		$css .= "
		}
		</style>
		
		<!--[if IE 7]>
		<link rel='stylesheet' href='modules/mod_tpcontentslider/tpcontentslider/ie7.css' type='text/css' media='projection, screen' />
	<![endif]-->
	<!--[if IE 6]>
		<link rel='stylesheet' href='modules/mod_tpcontentslider/tpcontentslider/ie6.css' type='text/css' media='projection, screen' />
	<![endif]-->
		";

		$document->addCustomTag($css);
	}
	
	$document->addScript($mainframe->getBasePath( 0, true ).'/modules/mod_tpcontentslider/tpcontentslider/slider.js.php?mid='.$moduleid);

	if(!function_exists('lnd_limittext')) {
	function lnd_limittext($txt,$limit)
	{
	    $len=strlen($txt);
	    if ($len <= $limit)
	        return $txt;
	    else
	    {
	        $txt = substr($txt,0,$limit);
	        $pos = strrpos($txt," ");
	        if($pos >0)
			{
		        $txt = substr($txt,0,$pos);
		    	if (($tpos =strrpos($txt,"<")) >  strrpos($txt,">") && $tpos>0)
		    	{
			  		$txt = substr($txt,0,$tpos-1);
			  	}
			}
	        return $txt . "...";
	    }
	}
	}

	if(!function_exists('unhtmlentities')){
		function unhtmlentities ($string){
	    // replace numeric entities
	    $string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
	    $string = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $string);
	    // replace literal entities
	    $trans_tbl = get_html_translation_table(HTML_ENTITIES);
	    $trans_tbl = array_flip($trans_tbl);
	    return strtr($string, $trans_tbl);
	  }
	}

?>
	<div class="tpc_slider" id="tpc_slider<?php echo $moduleid; ?>">
		

		<div id="scroll" class="scroll<?php echo $moduleid; ?>">
			<div id="scrollContainer" class="scrollContainer<?php echo $moduleid; ?>">
				<?php foreach($tpcontentslider as $tpcontent) { ?>
				<div class="panel" id="<?php echo str_replace(array(" ", ",",".","-","_","'","\"","~","!","@","#","$","%","^","&","*","(",")","+","=","`","[","]","{","}",":",";","<",">","?","/"), "", strtolower($tpcontent->title)) . $moduleid . $tpcontent->id . "go"; ?>">
					<?php if($show_title) { ?>
					<h2><?php echo $tpcontent->title; ?></h2>
					<?php } ?>
					<?
					$tpcontent->introtext= preg_replace("/{[^}]*}/","",$tpcontent->introtext);
					$tpcontent->introtext = strip_tags(stripcslashes(htmlspecialchars_decode($tpcontent->introtext)), '<img>');
				  if($limit > 0) {
				  	$tpcontent->introtext = lnd_limittext($tpcontent->introtext,$limit);
					}
					?>
					<p><?php echo $tpcontent->introtext; ?></p>
				</div>
				<?php } ?>
			</div>
		</div>
		
		<?php if($show_tab_name) { ?>
  	<ul id="navigation" class="navigation<?php echo $moduleid; ?>">
			<?php foreach($tpcontentslider as $tpcontent) { ?>
			<li id="<?php echo str_replace(array(" ", ",",".","-","_","'","\"","~","!","@","#","$","%","^","&","*","(",")","+","=","`","[","]","{","}",":",";","<",">","?","/"), "", strtolower($tpcontent->title)) . $moduleid . $tpcontent->id; ?>"><a href="#<?php echo str_replace(array(" ", ",",".","-","_","'","\"","~","!","@","#","$","%","^","&","*","(",")","+","=","`","[","]","{","}",":",";","<",">","?","/"), "", strtolower($tpcontent->title)) . $moduleid . $tpcontent->id; ?>go"><?php echo $tpcontent->title; ?></a></li>
			<?php } ?>
     </ul>
		<?php } ?>
		
	</div>
<?php
}
?>