<?php
/**
TPBox
Mambot System for Lightbox Mambot
http://www.templateplazza.com
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

$_MAMBOTS->registerFunction( 'onPrepareContent', 'botTPBox' );

/**
*/
function botTPBox( $published, &$row, &$params, $page=0 ) {
	global $database, $_MAMBOTS;
	
	// simple performance check to determine whether bot should process further
	if ( strpos( $row->text, 'tpbox' ) === false ) {
		return true;
	}

	$arrayFind = array("type", "text", "width", "height", "title", "desc");
	if(preg_match_all("#{tpbox(.*?){/tpbox}#s", $row->text, $matches, PREG_PATTERN_ORDER) > 0) {
		global $mosConfig_live_site, $mainframe;

		$buf = ob_get_contents();
		if (!empty($buf) && !headers_sent()) {
			if (!preg_match("/\tpbox_multibox\b/i", $buf)) {
				$html = '<link href="'.$mosConfig_live_site.'/mambots/content/tpbox/tpbox_multibox.css" rel="stylesheet" type="text/css" />';
				$mainframe->addCustomHeadTag($html);
			}
			if (!preg_match("/\tpbox_ie6\b/i", $buf)) {
				$html = '<!--[if lte IE 6]><link href="'.$mosConfig_live_site.'/mambots/content/tpbox/tpbox_ie6.css" rel="stylesheet" type="text/css" /><![endif]-->';
				$mainframe->addCustomHeadTag($html);
			}

			if (!preg_match("/\bmootools\b/i", $buf)) {
				$html = '<script type="text/javascript" src="'.$mosConfig_live_site.'/mambots/content/tpbox/mootools.js"></script>';
				$mainframe->addCustomHeadTag($html);
			}
			if (!preg_match("/\tpbox_overlay\b/i", $buf)) {
				$html = '<script type="text/javascript" src="'.$mosConfig_live_site.'/mambots/content/tpbox/tpbox_overlay.js"></script>';
				$mainframe->addCustomHeadTag($html);
			}
			if (!preg_match("/\tpbox_multibox\b/i", $buf)) {
				$html = '<script type="text/javascript" src="'.$mosConfig_live_site.'/mambots/content/tpbox/tpbox_multibox.js"></script>';
				$mainframe->addCustomHeadTag($html);
			}
	
		}
		ob_clean();
		for($n=0;$n<count($matches[0]);$n++) {
			$mb = $n+1;
		  preg_match_all("#}}(.*?){/tpbox}#s", $matches[0][$n], $m1, PREG_PATTERN_ORDER);
		  $content = $m1[1][0];
			foreach($arrayFind as $find) {
			  preg_match_all("#".$find."={(.*?)}#s", $matches[0][$n], $m2, PREG_PATTERN_ORDER);
			  $$find = $m2[1][0];
			}
			switch(strtolower($type)) {
				case "image":
					$newText = '<a href="'.$content.'" id="mb'.$mb.'" class="mb" title="'.$title.'">'.tpbox_unhtmlentities($text).'</a>';
					$newText .= '<div class="multiBoxDesc mb'.$mb.'">'.tpbox_unhtmlentities($desc).'</div>';
					$row->text = str_replace($matches[0][$n], $newText, $row->text);
					break;
				case "movie":
					$newText = '<a href="'.$content.'" rel="width:'.$width.',height:'.$height.'" id="mb'.$mb.'" class="mb" title="'.$title.'">'.tpbox_unhtmlentities($text).'</a>';
					$newText .= '<div class="multiBoxDesc mb'.$mb.'">'.tpbox_unhtmlentities($desc).'</div>';
					$row->text = str_replace($matches[0][$n], $newText, $row->text);
					break;
				case "mp3":
					$newText = '<a href="'.$content.'" rel="" id="mb'.$mb.'" class="mb" title="'.$title.'">'.tpbox_unhtmlentities($text).'</a>';
					$newText .= '<div class="multiBoxDesc mb'.$mb.'">'.tpbox_unhtmlentities($desc).'</div>';
					$row->text = str_replace($matches[0][$n], $newText, $row->text);
					break;

				case "html":
					$newText = '<a href="'.$content.'" rel="width:'.$width.',height:'.$height.'" id="mb'.$mb.'" class="mb" title="'.$title.'">'.tpbox_unhtmlentities($text).'</a>';
					$newText .= '<div class="multiBoxDesc mb'.$mb.'">'.tpbox_unhtmlentities($desc).'</div>';
					$row->text = str_replace($matches[0][$n], $newText, $row->text);
					break;

				case "ajax":
					$newText = '<a href="'.$content.'" rel="width:'.$width.',height:'.$height.',ajax:true" id="mb'.$mb.'" class="mb" title="'.$title.'">'.tpbox_unhtmlentities($text).'</a>';
					$newText .= '<div class="multiBoxDesc mb'.$mb.'">'.tpbox_unhtmlentities($desc).'</div>';
					$row->text = str_replace($matches[0][$n], $newText, $row->text);
					break;

				case "htmlelement":
					$newText = '<a href="#htmlElement" rel="type:element" id="mb'.$mb.'" class="mb" title="'.$title.'">'.tpbox_unhtmlentities($text).'</a>';
					$newText .= '<div class="multiBoxDesc mb'.$mb.'">'.$desc.'</div>';
					$newText .= '<div id="htmlElement">'.tpbox_unhtmlentities($content).'</div>';
					$row->text = str_replace($matches[0][$n], $newText, $row->text);
					break;
			}
		}
	}
	$jsLoader = '<script type="text/javascript">
		var box = {};
		window.addEvent(\'domready\', function(){
			box = new MultiBox(\'mb\', {descClassName: \'multiBoxDesc\', useOverlay: true});
		});
	</script>';
	$row->text = $row->text . $jsLoader;


}

if(!function_exists('tpbox_unhtmlentities')) {
	function tpbox_unhtmlentities($string){
		// replace numeric entities
		$string = preg_replace('~&#x([0-9a-f]+);~ei', 'chr(hexdec("\\1"))', $string);
		$string = preg_replace('~&#([0-9]+);~e', 'chr("\\1")', $string);
		// replace literal entities
		$trans_tbl = get_html_translation_table(HTML_ENTITIES);
		$trans_tbl = array_flip($trans_tbl);
		return strtr($string, $trans_tbl);
	}
}
?>