<?php
/**
TP Menu System
Version: 1.0
Compability: Joomla 1.0.x

@author Jerry Wijaya and Andy Sikumbang
Copyright: 2008 - TemplatePlazza
**/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

//ERROR_REPORTING(E_ALL);
//error_reporting(E_ALL ^ E_NOTICE);

$menuname	= $params->get( 'menu', 'mainmenu' );
$menutype 	= $params->get( 'menutype', 'dropdown' );
$displaytype 	= $params->get( 'displaytype', 'standard' );
$animatedtype = $params->get( 'animatedtype', 'standard' );
$animatedFx = $params->get( 'animatedFx', 'Fx.Transitions.Bounce.easeOut' );

//Drop Column
$display_image_on_top_menu_dropcolumn = $params->get( 'display_image_on_top_menu_dropcolumn', '1' );
$display_image_with_text_on_top_menu_dropcolumn = $params->get( 'display_image_with_text_on_top_menu_dropcolumn', '1' );
$image_position_on_top_menu_dropcolumn = $params->get( 'image_position_on_top_menu_dropcolumn', '1' );

$display_image_on_sub_menu_dropcolumn = $params->get( 'display_image_on_sub_menu_dropcolumn', '1' );
$display_image_with_text_on_sub_menu_dropcolumn = $params->get( 'display_image_with_text_on_sub_menu_dropcolumn', '1' );
$image_position_on_sub_menu_dropcolumn = $params->get( 'image_position_on_sub_menu_dropcolumn', '1' );

//Drop Line
$display_image_on_top_menu_dropline = $params->get( 'display_image_on_top_menu_dropline', '1' );
$display_image_with_text_on_top_menu_dropline = $params->get( 'display_image_with_text_on_top_menu_dropline', '1' );
$image_position_on_top_menu_dropline = $params->get( 'image_position_on_top_menu_dropline', '1' );

$display_image_on_sub_menu_dropline = $params->get( 'display_image_on_sub_menu_dropline', '1' );
$display_image_with_text_on_sub_menu_dropline = $params->get( 'display_image_with_text_on_sub_menu_dropline', '1' );
$image_position_on_sub_menu_dropline = $params->get( 'image_position_on_sub_menu_dropline', '1' );

$image_suffix_hover = $params->get( 'image_suffix_hover', '' );

//parent menu
$display_image_on_top_menu = $params->get( 'display_image_on_top_menu', '1' );
$display_image_with_text_on_top_menu = $params->get( 'display_image_with_text_on_top_menu', '1' );
$image_position_on_top_menu = $params->get( 'image_position_on_top_menu', '1' );

//child menu
$display_image_on_sub_menu = $params->get( 'display_image_on_sub_menu', '1' );
$display_image_with_text_on_sub_menu = $params->get( 'display_image_with_text_on_sub_menu', '0' );
$image_position_on_sub_menu = $params->get( 'image_position_on_sub_menu', 'right' );
$display_image_option_on_sub_menu = $params->get( 'display_image_option_on_sub_menu', 'right' );

$display_image_level = $params->get( 'display_image_level', '1' );

$level_configured_1 = $params->get( 'level_configured_1', '1' );
$level_configured_2 = $params->get( 'level_configured_2', '1' );
$level_configured_3 = $params->get( 'level_configured_3', '1' );
$level_configured_4 = $params->get( 'level_configured_4', '1' );
$level_configured_5 = $params->get( 'level_configured_5', '1' );
$level_configured_6 = $params->get( 'level_configured_6', '1' );
$level_configured_7 = $params->get( 'level_configured_7', '1' );
$level_configured_8 = $params->get( 'level_configured_8', '1' );
$level_configured_9 = $params->get( 'level_configured_9', '1' );
$level_configured_10 = $params->get( 'level_configured_10', '1' );
$level_configured_11 = $params->get( 'level_configured_11', '1' );

$columns 	= $params->get( 'columns', 3 );
$start = 1;
$end 	= $params->get( 'end', 100 );
$openall = true;


function injectCustomHeadTags($html) {
	if($html) {
		$buf = ob_get_contents();
		$count = 0;
		if (!empty($buf) && !headers_sent()) {
			$buf = preg_replace("/<\/head>/", $html."</head>", $buf);
			if ($buf) {
				ob_clean();
				echo $buf;
				return true;
			}
		}
	}
	return false;
}

$html = "";
if ($animatedtype == "animated") {
	$buf = ob_get_contents();
	if (!empty($buf) && !headers_sent()) {
		if (!preg_match("/\bmootools\b/i", $buf)) {
			$html .= '<script type="text/javascript" src="'.$mosConfig_live_site.'/modules/mod_tpmenu/mootools.js"></script>';
	}
	$html .=  '<script type="text/javascript" src="'.$mosConfig_live_site.'/modules/mod_tpmenu/'.$menutype.'/menu.js.php?animated='.$animatedFx.'"></script>';		}
} else {
	if($menutype == "dolphin") {
		$html .=  '<script type="text/javascript" src="'.$mosConfig_live_site.'/modules/mod_tpmenu/'.$menutype.'/menu.js.php?animated='.$animatedFx.'"></script>';
	} else {
		$html .=  '<script type="text/javascript" src="'.$mosConfig_live_site.'/modules/mod_tpmenu/'.$menutype.'/menu2.js.php?animated='.$animatedFx.'"></script>';
	}
}


$default_css_absolute_path = $mosConfig_absolute_path."/templates/" . $mainframe->getTemplate() . "/css/" . $menutype . "tpmenu.css";
$default_css_live_site = $mosConfig_live_site."/templates/" . $mainframe->getTemplate() . "/css/" . $menutype . "tpmenu.css";

if (file_exists($default_css_absolute_path)) {
	$html .=  '<link href="'.$default_css_live_site.'" rel="stylesheet" type="text/css" />';
} else {
	$html .=  '<link href="'.$mosConfig_live_site.'/modules/mod_tpmenu/'.$menutype.'/menu.css" rel="stylesheet" type="text/css" />';
}

injectCustomHeadTags($html);

require($mosConfig_absolute_path."/modules/mod_tpmenu/".$menutype."/menu.php");

$dataMenu = array("menuname" => $menuname,
							"displaytype" => $displaytype,
							"animatedtype" => $animatedtype,
							"columns" => $columns,
							"openall" => $openall,
							"start" => $start,
							"end" => $end,
							"display_image_on_top_menu_dropcolumn" => $display_image_on_top_menu_dropcolumn,
							"display_image_with_text_on_top_menu_dropcolumn" => $display_image_with_text_on_top_menu_dropcolumn,
							"image_position_on_top_menu_dropcolumn" => $image_position_on_top_menu_dropcolumn,
							"display_image_on_sub_menu_dropcolumn" => $display_image_on_sub_menu_dropcolumn,
							"display_image_with_text_on_sub_menu_dropcolumn" => $display_image_with_text_on_sub_menu_dropcolumn,
							"image_position_on_sub_menu_dropcolumn" => $image_position_on_sub_menu_dropcolumn,
							"display_image_on_top_menu_dropline" => $display_image_on_top_menu_dropline,
							"display_image_with_text_on_top_menu_dropline" => $display_image_with_text_on_top_menu_dropline,
							"image_position_on_top_menu_dropline" => $image_position_on_top_menu_dropline,
							"display_image_on_sub_menu_dropline" => $display_image_on_sub_menu_dropline,
							"display_image_with_text_on_sub_menu_dropline" => $display_image_with_text_on_sub_menu_dropline,
							"image_position_on_sub_menu_dropline" => $image_position_on_sub_menu_dropline,
							"image_suffix_hover" => $image_suffix_hover,
							"display_image_on_top_menu" => $display_image_on_top_menu,
							"display_image_with_text_on_top_menu" => $display_image_with_text_on_top_menu,
							"image_position_on_top_menu" => $image_position_on_top_menu,
							"display_image_on_sub_menu" => $display_image_on_sub_menu,
							"display_image_with_text_on_sub_menu" => $display_image_with_text_on_sub_menu,
							"image_position_on_sub_menu" => $image_position_on_sub_menu,
							"display_image_option_on_sub_menu" => $display_image_option_on_sub_menu,
							"display_image_level" => $display_image_level,
							"level_configured_2" => $level_configured_2,
							"level_configured_3" => $level_configured_3,
							"level_configured_4" => $level_configured_4,
							"level_configured_5" => $level_configured_5,
							"level_configured_6" => $level_configured_6,
							"level_configured_7" => $level_configured_7,
							"level_configured_8" => $level_configured_8,
							"level_configured_9" => $level_configured_9,
							"level_configured_10" => $level_configured_10,
							"level_configured_11" => $level_configured_11);

$menu = new Menu($dataMenu);
echo $menu->display();

?>